//+------------------------------------------------------------------+
//|                                    _Candle_BB_Iluminator v.4.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property indicator_buffers 4
#property indicator_chart_window

extern   int      Total_Bars     = 800;
extern	int		LabelDistance	= 5;
extern   string   Set_HL_n_Modus = "------------";
enum __gv {
   _NONE_,
   ModusWep,
   HiLo};
input __gv  Tampilin_Garis_Virgin=ModusWep;
extern	string	Readme1			= "#--- Periode Huruf/Angka",
						Readme2			= "5M 15M 30M 1H 4H 8H 12H 16H",
						Readme3			= "1D 2D 3D 4D 1W 2W 3W 1MH 2MH 4MH 1Y",
						Batasan_Umur   = "16H";
extern   bool     Tampilin_Harga = 0;
extern   bool     Ray            = 0;
extern	bool		ALARM				= 1;
extern   color    High_Virgin    = White,
                  Low_Virgin     = White,
                  Upper_Virgin   = DodgerBlue,
                  Lower_Virgin   = DodgerBlue;
double   UPPER_DOT[],LOWER_DOT[],
			hiv[],lov[],HiV[],LoV[]; 
string	LabelName,Periode;
int      i,Per;
datetime tempe=0;
//+------------------------------------------------------------------+
int init(){
   
   Periode = Batasan_Umur;
   if(Periode == "4Y" || Periode == "4y")				{ Periode = "4Y";    Per = MathCeil((345600*4)/Period()); }
	else if(Periode == "1Y" || Periode == "1y")		{ Periode = "1Y";		Per = MathCeil(345600/Period()); }
	else if(Periode == "4MH"	|| Periode == "4mh")	{ Periode = "4MH";	Per = MathCeil(115200/Period()); }
	else if(Periode == "2MH"	|| Periode == "2mh")	{ Periode = "2MH";	Per = MathCeil(28800*2/Period()); }
	else if(Periode == "1MH"	|| Periode == "1mh")	{ Periode = "1MH";	Per = MathCeil(28800/Period()); }
	else if(Periode == "3W"		|| Periode == "3w")	{ Periode = "3W";		Per = MathCeil(7200*3/Period()); }
	else if(Periode == "2W"		|| Periode == "2w")	{ Periode = "2W";		Per = MathCeil(14400/Period()); }
	else if(Periode == "1W"		|| Periode == "1w")	{ Periode = "1W";		Per = MathCeil(7200/Period()); }
	else if(Periode == "4D"		|| Periode == "4d")	{ Periode = "4D";		Per = MathCeil(1440*4/Period()); }
	else if(Periode == "3D"		|| Periode == "3d")	{ Periode = "3D";		Per = MathCeil(1440*3/Period()); }
	else if(Periode == "2D"		|| Periode == "2d")	{ Periode = "2D";		Per = MathCeil(1440*2/Period()); }
	else if(Periode == "1D"		|| Periode == "1d")	{ Periode = "1D";		Per = MathCeil(1440/Period()); }
	else if(Periode == "16H"	|| Periode == "16h")	{ Periode = "16H";	Per = MathCeil(960/Period()); }
	else if(Periode == "12H"	|| Periode == "12h")	{ Periode = "12H";	Per = MathCeil(720/Period()); }
	else if(Periode == "8H"		|| Periode == "8h")	{ Periode = "8H";		Per = MathCeil(480/Period()); }
	else if(Periode == "4H"		|| Periode == "4h")	{ Periode = "4H";		Per = MathCeil(240/Period()); }
	else if(Periode == "1H"		|| Periode == "1h")	{ Periode = "1H";		Per = MathCeil(60/Period()); }
	else if(Periode == "30M"	|| Periode == "30m")	{ Periode = "30M";	Per = MathCeil(30/Period()); }
	else if(Periode == "15M"	|| Periode == "15m")	{ Periode = "15M";	Per = MathCeil(15/Period()); }
	else if(Periode == "5M"		|| Periode == "5m")	{ Periode = "5M";		Per = MathCeil(5/Period()); }
	else{                                                                Per = StrToInteger(Periode);}

	SetIndexStyle(0, DRAW_NONE);                                         SetIndexBuffer(0,UPPER_DOT);
	SetIndexStyle(1, DRAW_NONE);                                         SetIndexBuffer(1,LOWER_DOT);
	
	SetIndexStyle(2, DRAW_ARROW,0,2,High_Virgin); SetIndexArrow(2,159); SetIndexBuffer(2,HiV);
	SetIndexStyle(3, DRAW_ARROW,0,2,Low_Virgin);  SetIndexArrow(3,159); SetIndexBuffer(3,LoV);
   
	LabelName   = "KG_Virgin_";
	
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
  
   int obj_total;
	string name;
	obj_total=ObjectsTotal();
	for(i=obj_total;i>=0;i--){
		name	= ObjectName(i);
		if(StringFind(name, LabelName, 0) != -1)
			ObjectDelete(name);
	}
	
   return(0);
  }
//+------------------------------------------------------------------+
void IDV(string NAMA, string TEXT, int pos, datetime WAKTU, double HARGA,color WARNA){
if(Tampilin_Harga){

		if(ObjectFind(LabelName+NAMA) == -1)
			ObjectCreate(LabelName+NAMA, OBJ_ARROW, 0, WAKTU, HARGA);

		ObjectSet(LabelName+NAMA, OBJPROP_TIME1, WAKTU);
		ObjectSet(LabelName+NAMA, OBJPROP_PRICE1, HARGA);
		ObjectSet(LabelName+NAMA, OBJPROP_COLOR, WARNA);
		ObjectSet(LabelName+NAMA, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);}
}
//+------------------------------------------------------------------+
void SET_HLINE(string name, datetime Tm1, double Prc, color clr, int Lebar, int StyleKu=STYLE_SOLID){

   if(ObjectFind(LabelName+name) == -1){
		ObjectCreate(LabelName+name, OBJ_TREND,0,Tm1,Prc,Time[0],Prc);
		ObjectSet(LabelName+name, OBJPROP_RAY, Ray);
		ObjectSet(LabelName+name, OBJPROP_WIDTH, Lebar);
		ObjectSet(LabelName+name, OBJPROP_COLOR, clr);
		ObjectSet(LabelName+name, OBJPROP_STYLE, StyleKu);
		ObjectSet(LabelName+name, OBJPROP_BACK, false);
		ObjectSet(LabelName+name,OBJPROP_SELECTABLE,false);
	}
	ObjectSet(LabelName+name, OBJPROP_TIME1, Tm1);
	ObjectSet(LabelName+name, OBJPROP_TIME2, Time[0]);
	ObjectSet(LabelName+name, OBJPROP_PRICE1, Prc);
	ObjectSet(LabelName+name, OBJPROP_PRICE2, Prc);
   ObjectSet(LabelName+name, OBJPROP_RAY, Ray);
   
   if (ALARM == true && Bid-5*Point <= Prc && Bid+5*Point >= Prc) PlaySound("alert.wav");
}
//+------------------------------------------------------------------+
void Virgin_update(){

   int strlen,obj_total;
	  string name;
	  if(tempe!=Time[0])
     {
	  obj_total	= ObjectsTotal();
	  strlen		= StringLen(LabelName);
	  for(i=obj_total;i>=0;i--){
		name	= ObjectName(i);
		if(StringFind(name, LabelName, 0) != -1)
			ObjectDelete(name);
	  }
     tempe=Time[0];
     }
}
//+------------------------------------------------------------------+
int start(){

	// KG VIRGIN
//==========================================================================================================================		
   for (i=Total_Bars; i>=Per; i--) {	
	if(Close[i+2]<Close[i+1] && Close[i+1]>=Close[i]) UPPER_DOT[i+1] = Close[i+1]; else UPPER_DOT[i+1] = EMPTY_VALUE;
	if(Close[i+2]>Close[i+1] && Close[i+1]<=Close[i]) LOWER_DOT[i+1] = Close[i+1]; else LOWER_DOT[i+1] = EMPTY_VALUE;
	
   if(High[i+2]<High[i+1] && High[i+1]>=High[i]) HiV[i+1]=High[i+1]; else HiV[i+1] = EMPTY_VALUE;
   if(Low [i+2]>Low [i+1] && Low [i+1]<=Low [i]) LoV[i+1]=Low [i+1]; else LoV[i+1] = EMPTY_VALUE;
	}
//==========================================================================================================================		
   Virgin_update();
	for(i=Per; i<Total_Bars; i++){
      if(UPPER_DOT[i+1]!=EMPTY_VALUE){
         for(int j=i;j>=0;j--){
            if(UPPER_DOT[i+1]<Close[j]){
            break;
            }            
            if(j==0 && Tampilin_Garis_Virgin!=_NONE_){
               if (Tampilin_Garis_Virgin==ModusWep){
                  SET_HLINE("Upper "+i,  Time[i+1], UPPER_DOT[i+1], Upper_Virgin,0,2);
                  IDV("Hi "+i,  "Hi",1, Time[0], UPPER_DOT[i+1], Upper_Virgin);}
            }
         }
      }
      
      if(LOWER_DOT[i+1]!=EMPTY_VALUE){
         for(j=i;j>=0;j--){
            if(LOWER_DOT[i+1]>Close[j]){
            break;
            }                   
            if(j==0 && Tampilin_Garis_Virgin!=_NONE_){
               if (Tampilin_Garis_Virgin==ModusWep){
                  SET_HLINE("Lower "+i,  Time[i+1], LOWER_DOT[i+1], Lower_Virgin,0,2);
                  IDV("Lo "+i,  "Lo",1, Time[0], LOWER_DOT[i+1], Lower_Virgin);}
            }
         }
      }  
      
      if(HiV[i+1]!=EMPTY_VALUE){
         for(j=i;j>=0;j--){
            if(HiV[i+1]<High[j]){
            HiV[i+1]=EMPTY_VALUE;
            break;
            }            
            if(j==0 && Tampilin_Garis_Virgin!=_NONE_){
               if (Tampilin_Garis_Virgin==HiLo){
                  SET_HLINE("gHi "+i,  Time[i+1], HiV[i+1], Upper_Virgin,0,2);
                  IDV("Hi "+i,  "Hi",1, Time[0], HiV[i+1], Upper_Virgin);}
            }
         }
      }
      
      if(LoV[i+1]!=EMPTY_VALUE){
         for(j=i;j>=0;j--){
            if(LoV[i+1]>Low[j]){
            LoV[i+1]=EMPTY_VALUE;
            break;
            }                   
            if(j==0 && Tampilin_Garis_Virgin!=_NONE_){
               if (Tampilin_Garis_Virgin==HiLo){
                  SET_HLINE("gLo "+i,  Time[i+1], LoV[i+1], Lower_Virgin,0,2);
                  IDV("Low "+i, "Lo",1, Time[0],  LoV[i+1], Lower_Virgin);}
            }
         }
      }  
   } 
//----
   return(0);
  }
//+------------------------------------------------------------------+